/**
 * @copyright 2018 sugarsLab.com All rights reserved.
 * @author TANGTANG
 * @email 9164654@qq.com
 * @date 2018年11月8日
 * @version 0.0.1
 * @ClassName SugarApp
 * @description SugarApp 
 */

(function(global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
		typeof define === 'function' && define.amd ? define(factory) :
		(global.SugarApp = factory());
}(this, (function() {

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是未定义
	 */
	function isUndef(params) {
		return params === undefined || params === null;
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是 不是未定义
	 */
	function isNotUndefined(params) {
		return params !== undefined && params !== null;
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是真吗
	 */
	function isTrue(params) {
		return params === true;
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是假吗
	 */
	function isFalse(params) {
		return params === false;
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是对象吗
	 */
	function isObject(params) {
		return Object.prototype.toString.call(params) === "[object Object]" && JSON.stringify(params) !== "{}";
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是数组吗
	 */
	function isArray(params) {
		return Object.prototype.toString.call(params) === "[object Array]";
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是字符串吗
	 */
	function isString(params) {
		return Object.prototype.toString.call(params) === "[object String]" && params !== "";
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是空对象吗
	 */
	function isEmptyObject(param) {
		return JSON.stringify(param) === "{}";
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是inout节点吗
	 */
	function isTagNameByInput(params) {
		return params.tagName === "INPUT" || params.tagName === "TEXTAREA";
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是A节点吗
	 */
	function isTagNameByA(params) {
		return params.tagName === "A";
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 不是Null
	 */
	function isNotNull(params) {
		return params !== null && params.length > 0;
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月26日
	 * @version 1.0
	 * @description 是SugarApp
	 */
	function isSugarApp() {
		return this instanceof SugarApp;
	};

	function console() {
		return window.console;
	}

	function querySelector(ele) {
		return document.querySelector(ele);
	}

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月8日
	 * @version 1.0
	 * @description SugarApp类
	 */
	var SugarApp = function() {
		if(arguments.length === 1) {
			if(isString(arguments[0])) {
				//待开发
			} else if(isObject(arguments[0])) {
				this.loader(arguments);
			}
		} else if(arguments.length === 4) {
			this.watcher(arguments);
		} else {
			throw new Error("param 错误.");
		}
	};

	initSugarApp(SugarApp);
	initWatcher(SugarApp);
	initCompile(SugarApp);

	function initSugarApp(SugarApp) {

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 加载SugarApp 初始化参数
		 */
		SugarApp.prototype.loader = function(params) {
			var param = params[0];
			if(!isObject(param))
				throw new Error("constructor param 必须是一个对象.");
			if(!isString(param.ele))
				throw new Error("param ele 必须是一个字符串.");
			if(!isObject(param.data))
				throw new Error("param data 必须是一个对象.");
			this.binded = {};
			this.params = param;
			this.ele = querySelector(param.ele);
			this.data = param.data;
			this.methods = param.methods;
			this.autoLoad = param.autoLoad == undefined ? false : param.autoLoad;
			if(this.autoLoad)
				this.init();
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 监听数据的变化
		 */
		SugarApp.prototype.handler = function(data) {
			if(isEmptyObject(data) && !isObject(data))
				throw new Error("data必须是个对象");
			var self = this;
			Object.keys(data).forEach(function(v) {
				var ov = data[v];
				if(isObject(ov)) {
					Object.keys(ov).forEach(function(i) {
						console.log("ov[i]" + ov[i]);
						if(!isObject(ov[i]) && isNotUndefined(ov[i])) {
							console.log("-" + i + ov[i]);
							v += "-" + i;
							ov = ov[i];
						} else if(isObject(ov[i]) && isNotUndefined(ov[i])) {
							console.log("object--" + ov[i]);
						}
					});
				} else if(isArray(ov)) {
					console.log("array-" + ov + v);
					for(var j = 0; j < ov.length; j++) {
						console.log(ov[j]);
						v += "-" + j;
						ov = ov[j];
					}
				}
				self.binded[v] = {
					instruct: []
				};
				Object.defineProperty(data, v, {
					set: function(value) {
						if(ov != value) {
							ov = value;
							self.binded[v].instruct.forEach(function(ret) {
								ret.updateView();
							});
						}
					},
					get: function() {
						return ov;
					}
				});
			});
		};

	};

	function initWatcher(SugarApp) {

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 用来绑定更新函数，实现对dom的更新
		 */
		SugarApp.prototype.watcher = function(params) {
			if(params.length === 4) {
				this.watcherKey = new Array(4);
				for(var i = 0; i < this.watcherKey.length; i++) {
					this.watcherKey[i] = params[i];
				}
				this.updateView();
			} else {
				throw new Error("params error.");
			}
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 更新view 函数
		 */
		SugarApp.prototype.updateView = function() {
			if("input" === this.watcherKey[0]) {
				this.watcherKey[1]["value"] = this.watcherKey[2].data[this.watcherKey[3]];
			} else if("text" === this.watcherKey[0]) {
				this.watcherKey[1]["innerHTML"] = this.watcherKey[2].data[this.watcherKey[3]];
			}
		};
	};

	function initCompile(SugarApp) {

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 解析dom 上的注解
		 */
		SugarApp.prototype.viewParser = function(eleObj) {
			this.recursionFn(eleObj);
			this.compileInner(eleObj);
			this.compileValue(eleObj);
			this.compileClick(eleObj);
			this.compileBraces(eleObj);
			this.compileHref(eleObj);
			this.compileModel(eleObj);
			this.compileType(eleObj);
			this.compileAjax(eleObj);
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 递归查找标签函数
		 */
		SugarApp.prototype.recursionFn = function(eleObj) {
			var self = this;
			for(var i = 0; i < eleObj.children.length; i++) {
				if(eleObj.children[i].children.length) self.viewParser(eleObj.children[i]);
			}
		}

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 扫面标签上 @value 注解
		 */
		SugarApp.prototype.compileValue = function(eleObj) {
			var self = this;
			for(var i = 0; i < eleObj.children.length; i++) {
				if(eleObj.children[i].hasAttribute("@value") && isTagNameByInput(eleObj.children[i])) {
					var attributeValue = eleObj.children[i].getAttribute("@value");
					if(attributeValue != "") {
						self.binded[attributeValue].instruct.push(new SugarApp("input", eleObj.children[i], self, attributeValue));
					}
				}
			}
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 扫面标签上 @click 注解
		 */
		SugarApp.prototype.compileClick = function(eleObj) {
			var self = this;
			if(self.methods) {
				for(var i = 0; i < eleObj.children.length; i++) {
					if(eleObj.children[i].hasAttribute("@click")) {
						eleObj.children[i].addEventListener('click', (function(e) {
							var attrV = eleObj.children[i].getAttribute("@click");
							if(attrV != "") {
								return self.methods[attrV];
							}
						})(i));
					}
				}
			}
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月8日
		 * @version 1.0
		 * @description 扫面标签上 {{}} 注解
		 */
		SugarApp.prototype.compileBraces = function(eleObj) {
			var self = this;
			for(var i = 0; i < eleObj.children.length; i++) {
				var textContent = eleObj.children[i].textContent;
				var reg = /\{\{([^}]+)\}\}/g;
				if(reg.test(textContent) && !isTagNameByInput(eleObj.children[i])) {
					var attributeValue = textContent.replace("{{", "").replace("}}", "");
					if(attributeValue != "") {
						if(attributeValue.indexOf(".") >= 0) {
							attributeValue = attributeValue.replace(".", "-");
						}
						self.binded[attributeValue].instruct.push(new SugarApp("text", eleObj.children[i], self, attributeValue));
					}
				}
			}
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月9日
		 * @version 1.0
		 * @description 扫面标签上 @href 注解 禁止 a 标签超链接
		 */
		SugarApp.prototype.compileHref = function(eleObj) {
			var self = this;
			for(var i = 0; i < eleObj.children.length; i++) {
				if(eleObj.children[i].hasAttribute("@href") && isTagNameByA(eleObj.children[i])) {
					var attributeValue = eleObj.children[i].getAttribute("@href");
					if(attributeValue == "") {
						eleObj.children[i].href = "javascript:void(0);";
						eleObj.children[i].style.textDecoration = "none";
						eleObj.children[i].style.color = "#000";
					} else {
						eleObj.children[i].href = attributeValue;
					}
				}
			}
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月9日
		 * @version 1.0
		 * @description 扫面标签上 @inner 注解
		 */
		SugarApp.prototype.compileInner = function(eleObj) {
			var self = this;
			for(var i = 0; i < eleObj.children.length; i++) {
				if(eleObj.children[i].hasAttribute("@inner") && !isTagNameByInput(eleObj.children[i])) {
					var attributeValue = eleObj.children[i].getAttribute("@inner");
					if(attributeValue != "") {
						self.binded[attributeValue].instruct.push(new SugarApp("text", eleObj.children[i], self, attributeValue));
					}

				}
			}
		};

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月9日
		 * @version 1.0
		 * @description 扫面标签上 @model 注解
		 */
		SugarApp.prototype.compileModel = function(eleObj) {
			var self = this;
			for(var i = 0; i < eleObj.children.length; i++) {
				if(eleObj.children[i].hasAttribute("@model") && isTagNameByInput(eleObj.children[i])) {
					eleObj.children[i].addEventListener('input', (function(e) {
						var attributeValue = eleObj.children[i].getAttribute('@model');
						self.binded[attributeValue].instruct.push(new SugarApp("input", eleObj.children[i], self, attributeValue));
						return function() {
							self.data[attributeValue] = eleObj.children[e].value;
						}
					})(i));
				}
			}
		};

		String.prototype.replaceAll = function(s1, s2) {
			return this.replace(new RegExp(s1, "gm"), s2);
		}

		/**
		 * @copyright 2018 sugarsLab.com All rights reserved.
		 * @author TANGTANG
		 * @email 9164654@qq.com
		 * @date 2018年11月9日
		 * @version 1.0
		 * @description 扫面标签上 @type 注解
		 */
		SugarApp.prototype.compileType = function(eleObj) {
			var self = this;
			var typeArr = [
				"@input:type",
				"@input:readonly",
				"@input:button",
				"@input:checkbox",
				"@input:color",
				"@input:date",
				"@input:datetime",
				"@input:datetime-local",
				"@input:month",
				"@input:week",
				"@input:time",
				"@input:email",
				"@input:file",
				"@input:hidden",
				"@input:image",
				"@input:number",
				"@input:password",
				"@input:radio",
				"@input:range",
				"@input:reset",
				"@input:search",
				"@input:submit",
				"@input:tel",
				"@input:text",
				"@input:url"
			];
			for(var i = 0; i < eleObj.children.length; i++) {
				for(var j = 0; j < typeArr.length; j++) {
					if(eleObj.children[i].hasAttribute(typeArr[j]) && isTagNameByInput(eleObj.children[i])) {
						if(typeArr[j] == "@input:type") {
							var attributeValue = eleObj.children[i].getAttribute("@input:type");
							if(attributeValue != "") {
								eleObj.children[i].type = attributeValue;
							}
						} else if(typeArr[j] == "@input:readonly") {
							eleObj.children[i].readOnly = true;
						} else {
							var type = typeArr[j].replace("@input:", "");
							eleObj.children[i].type = type;
						}
					}
				}
			}
		};

		var AJAX_RE = /\{\'type\':([^}]+)\,\'url\':([^}]+)\,\'data\':([^}]+)\}/g;
		SugarApp.prototype.compileAjax = function(eleObj) {
			for(var i = 0; i < eleObj.children.length; i++) {
				if(eleObj.children[i].hasAttribute("@ajax")) {
					var v = eleObj.children[i].getAttribute("@ajax");
					if(!AJAX_RE.test(v)) {
						throw new Error("@ajax " + eleObj.children[i].outerHTML + " 参数错误.");
					}
					var jsonObject = v.replaceAll("'", "\"");
					var j = JSON.parse(jsonObject);
					this.ajax(j['type'], j['url'], j['data'], function(ret) {
						console().log(ret);
					});
				}
			}
		};
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月9日
	 * @version 1.0
	 * @description object.ajax
	 */
	SugarApp.prototype.ajax = function(type, url, data, success, error) {
		var xhr = null;
		if(window.XMLHttpRequest) {
			xhr = new XMLHttpRequest();
		} else {
			xhr = new ActiveXObject('Microsoft.XMLHTTP');
		}

		var type = type.toUpperCase();
		var random = Math.random();
		if(typeof data == 'object') {
			var str = '';
			for(var key in data)
				str += key + '=' + data[key] + '&';
			data = str.replace(/&$/, '');
		}

		if(type == 'GET') {
			if(data)
				xhr.open('GET', url + '?' + data, true);
			else
				xhr.open('GET', url + '?t=' + random, true);
			xhr.send();
		} else if(type == 'POST') {
			xhr.open('POST', url, true);
			xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			xhr.send(data);
		}
		xhr.onreadystatechange = function() {
			if(xhr.readyState == 4 && xhr.status == 200)
				success(JSON.parse(xhr.responseText));
			else if(error)
				error(xhr.status);
		}
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月9日
	 * @version 1.1
	 * @description setData
	 * @param params 对象 设置属性的对象  例子 {key:value}
	 */
	SugarApp.prototype.setData = function() {
		var params = arguments;
		if(params.length === 1 && isObject(params[0])) {
			for(var key in params[0]) {
				this.data[key] = params[0][key];
			}
		} else if(params.length === 2 && isString(params[0]) && isString(params[1])) {
			this.data[params[0]] = params[1];
		} else {
			throw new Error("setData 参数错误.");
		}
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月9日
	 * @version 1.1
	 * @description getData
	 * @param params 对象 设置属性的对象  例子 object.getData("key")
	 */
	SugarApp.prototype.getData = function() {
		var params = arguments;
		if(params.length === 0) {
			throw new Error("getData 参数错误.");
		} else if(params.length === 1 && isString(params[0])) {
			return this.data[params[0]];
		} else {
			var v = new Array(params.length);
			for(var i = 0; i < params.length; i++) {
				v[i] = this.data[params[i]];
			}
			return v;
		}
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月9日
	 * @version 1.0
	 * @description getData
	 * @param params 对象 设置属性的对象  例子 object.setStorage("key"，"value")
	 */
	SugarApp.prototype.setStorage = function(key, value) {
		window.localStorage.setItem(key, value);
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月9日
	 * @version 1.0
	 * @description getData
	 * @param params 对象 设置属性的对象  例子 object.getStorage("key")
	 */
	SugarApp.prototype.getStorage = function(key) {
		return window.localStorage.getItem(key);
	};

	/**
	 * @copyright 2018 sugarsLab.com All rights reserved.
	 * @author TANGTANG
	 * @email 9164654@qq.com
	 * @date 2018年11月8日
	 * @version 1.0
	 * @description 初始化函数
	 */
	SugarApp.prototype.init = function() {
		if(this.data) {
			this.handler(this.data);
		}
		if(this.ele) {
			this.viewParser(this.ele);
		}
	};

	SugarApp.prototype.isTrue = function(param) {
		return isTrue(param);
	};

	SugarApp.prototype.isFalse = function(param) {
		return isFalse(param);
	};

	SugarApp.prototype.alert = function(value) {
		window.alert(value);
	};

	SugarApp.prototype.byId = function(ele) {
		return document.getElementById(ele);
	};

	return SugarApp;

})));